package com.hzya.frame.plugin.wsdata.plugin;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.seeyon.customer.service.ICustomerService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.Session;
import com.jcraft.jsch.SftpATTRS;
import com.jcraft.jsch.SftpException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;


/**
 * 主数据模版(MdmModule)表服务接口
 *
 * @author makejava
 * @since 2024-06-18 10:33:32
 */
public class WsDataInitializer extends PluginBaseEntity {
    @Autowired
    private ICustomerService customerService;
    Logger logger = LoggerFactory.getLogger(WsDataInitializer.class);

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "WsDataInitializer";
    }

    @Override
    public String getPluginName() {
        return "获取CRM客户档案";
    }

    @Override
    public String getPluginLabel() {
        return "WsDataInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }


    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
        JsonResultEntity result = new JsonResultEntity();
        try {
            result =customerService.getCrmCustomer(requestJson);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return result;
    }

}
